package example;

import cgl.axis.services.*;
import cgl.fthpis.datatype.*;
import cgl.fthpis.generic.datatype.*;
import cgl.fthpis.generic.datatype.AuthInfoDocument;
import cgl.util.BootStrap;
import java.util.Properties;

public class PublishSession {

    private static Properties bootstrap = null;
    private static HYBRID_SERVICEStub stub = null;

    public PublishSession() {

        try {
            // Load bootsrap configuration
            try {
                bootstrap = BootStrap.loadProperties("properties.properties");
            } catch (Exception e1) {
                System.out.println(
                        "Here looking at /usr/local/wscontext/ folder for properties file.");
                try {
                    bootstrap = BootStrap.loadProperties(
                            "/usr/local/wscontext/properties.properties");
                } catch (Exception e2) {
                    System.out.println(
                            "Here looking at /tmp/wscontext/ folder for properties file.");
                    try {
                        bootstrap = BootStrap.loadProperties(
                                "/tmp/wscontext/properties.properties");
                    } catch (Exception e3) {
                        System.out.println("Error in loading Property file. " +
                                           e3.getMessage());
                        System.exit(1);
                    }
                }
            }

        } catch (Exception ex) {
            ex.printStackTrace();
        }

        String wsdl = bootstrap.getProperty("UDDI_WSContext_WSDL");
        /////////////////////////////////////////////////////////////////

        try {
            stub = new HYBRID_SERVICEStub(null, wsdl);
        } catch (Exception ex) {
            ex.printStackTrace();
        }

        String respondXML = "";

        cgl.fthpis.datatype.GetAuthTokenDocument tDoc1 = cgl.fthpis.datatype.
                GetAuthTokenDocument.Factory.newInstance();
        cgl.fthpis.datatype.GetAuthToken token = tDoc1.addNewGetAuthToken();
        token.setUserID("uddi_user");
        token.setCred("changeIt");
        System.out.println(tDoc1.xmlText());
        cgl.fthpis.generic.datatype.HybridFunctionDocument authDoc = cgl.
                fthpis.generic.datatype.
                HybridFunctionDocument.Factory.newInstance();
        cgl.fthpis.generic.datatype.HybridFunction hybridFunc1 = authDoc.
                addNewHybridFunction();
        hybridFunc1.setSpecName("WS-CONTEXT");
        hybridFunc1.setMethodName("get_authToken");
        hybridFunc1.setRequestXML(tDoc1.copy());
        /////////////////////////////////////////////////////////////////

        HYBRID_SERVICEStub.Input input1 = new HYBRID_SERVICEStub.Input();
        input1.setInput(authDoc.xmlText());
        HYBRID_SERVICEStub.Output output1 = null;
        try {
            output1 = stub.hybrid_function(input1);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        respondXML = output1.getOutput();
        System.out.println("respondXML = " + respondXML);
        /////////////////////////////////////////////////////////////////

        cgl.fthpis.datatype.AuthInfoDocument atDoc1 = null;
        try {
            atDoc1 = cgl.fthpis.datatype.AuthInfoDocument.Factory.parse(
                    respondXML);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        cgl.fthpis.datatype.AuthInfo authinfo = atDoc1.getAuthInfo();
        try {
            cgl.fthpis.generic.datatype.AuthInfoDocument at_Doc = cgl.
                    fthpis.generic.datatype.AuthInfoDocument.Factory.
                    newInstance();
            cgl.fthpis.generic.datatype.AuthInfo a__info = at_Doc.
                    addNewAuthInfo();
            a__info.setValue(authinfo.getValue());
            a__info.setPublisherID(authinfo.getPublisherID());
            respondXML = at_Doc.xmlText();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        String auth = respondXML;
        System.out.println(auth);
        cgl.fthpis.generic.datatype.AuthInfoDocument at_Doc = null;
        try {
            at_Doc = cgl.fthpis.generic.datatype.AuthInfoDocument.Factory.parse(
                    auth);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        cgl.fthpis.generic.datatype.AuthInfo auth_info = at_Doc.getAuthInfo();
        System.out.println("authinfo value = " + auth_info.getValue());
        System.out.println("authinfo publisher ID = " +
                           auth_info.getPublisherID());

        /////////////////////////////////////////////////////////////////
        cgl.fthpis.datatype.SaveSessionDocument pDoc = cgl.fthpis.datatype.
                SaveSessionDocument.Factory.newInstance();
        cgl.fthpis.datatype.SaveSession savesession = pDoc.addNewSaveSession();

        cgl.fthpis.datatype.SessionEntity[] session_arr = new cgl.fthpis.
                datatype.SessionEntity[1];

        cgl.fthpis.datatype.SessionEntityDocument aDoc = cgl.fthpis.datatype.
                SessionEntityDocument.Factory.newInstance();
        cgl.fthpis.datatype.SessionEntity session = aDoc.addNewSessionEntity();

        cgl.fthpis.datatype.LeaseDocument ldoc = cgl.fthpis.datatype.
                                                 LeaseDocument.Factory.
                                                 newInstance();
        cgl.fthpis.datatype.Lease context_lease = ldoc.addNewLease();
        context_lease.setIsInfinite(true);

        cgl.fthpis.datatype.Description aDesc = cgl.fthpis.datatype.
                                                DescriptionDocument.Factory.
                                                newInstance().addNewDescription();
        aDesc.setValue("description");

        session.setLease(context_lease);
        session.setName("context name");
        session.setDescription(aDesc);
        session.setLease(context_lease);

        session_arr[0] = session;
        savesession.setSessionEntityArray(session_arr);

        System.out.println(savesession.xmlText());
        System.out.println(pDoc.xmlText());
        respondXML = "";
        cgl.fthpis.datatype.SessionEntity[] session_entity_arr = null;

        cgl.fthpis.generic.datatype.HybridFunctionDocument setDoc = cgl.
                fthpis.generic.datatype.
                HybridFunctionDocument.Factory.newInstance();
        cgl.fthpis.generic.datatype.HybridFunction hybrid_Func = setDoc.
                addNewHybridFunction();
        hybrid_Func.setSpecName("WS-CONTEXT");
        hybrid_Func.setMethodName("save_session");
        hybrid_Func.setRequestXML(pDoc.copy());
        setDoc.setHybridFunction(hybrid_Func);

        HYBRID_SERVICEStub.Input _input = new HYBRID_SERVICEStub.Input();
        System.out.println("setDoc.xmlText() = " + setDoc.xmlText());
        _input.setInput(setDoc.xmlText());
        HYBRID_SERVICEStub.Output _output = null;
        try {
            _output = stub.hybrid_function(_input);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        respondXML = _output.getOutput();

        cgl.fthpis.datatype.SessionDetailDocument cDoc = null;
        try {
            cDoc = cgl.fthpis.datatype.SessionDetailDocument.Factory.parse(
                    respondXML);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        cgl.fthpis.datatype.SessionDetail cdetail = cDoc.getSessionDetail();

        session_entity_arr = cdetail.getSessionEntityArray();

        String key = null;
        for (int i = 0; i < session_entity_arr.length; i++) {
            cgl.fthpis.datatype.SessionEntity session_entity =
                    session_entity_arr[i];
            key = session_entity.getSessionKey();
            System.out.println("session_entity => session key = " + key);
            System.out.println("session_entity => session name = " +
                               session_entity.getName());
            if (session_entity.getDescription() != null) {
                System.out.println("session_entity => session desc = " +
                                   session_entity.getDescription().getValue());
            }
            cgl.fthpis.datatype.Lease lease = session_entity.getLease();
            if (lease != null) {
                System.out.println("context is infinite = " +
                                   lease.getIsInfinite());
            }
        }

        /////////////////////////////////////////////////////////////////
        cgl.fthpis.datatype.GetSessionDetailDocument _pDoc = cgl.fthpis.
                datatype.
                GetSessionDetailDocument.Factory.newInstance();
        cgl.fthpis.datatype.GetSessionDetail gsessionDetail = _pDoc.
                addNewGetSessionDetail();

        String[] arr = new String[1];
        arr[0] = key;

        //gsessionDetail.setAuthInfo(authinfo);
        gsessionDetail.setSessionKeyArray(arr);

        _pDoc.setGetSessionDetail(gsessionDetail);

        System.out.println(_pDoc.xmlText());

        respondXML = "";

        cgl.fthpis.datatype.SessionEntity[] _session_arr = null;

        cgl.fthpis.generic.datatype.HybridFunctionDocument getDoc = cgl.
                fthpis.generic.datatype.
                HybridFunctionDocument.Factory.newInstance();
        cgl.fthpis.generic.datatype.HybridFunction hybrid__Func = getDoc.
                addNewHybridFunction();
        hybrid__Func.setSpecName("WS-CONTEXT");
        hybrid__Func.setMethodName("get_sessionDetail");
        hybrid__Func.setRequestXML(_pDoc.copy());

        /////////////////////////////////////////////////////////////////
        HYBRID_SERVICEStub.Input __input = new HYBRID_SERVICEStub.Input();
        __input.setInput(getDoc.xmlText());
        HYBRID_SERVICEStub.Output __output = null;
        try {
            __output = stub.hybrid_function(__input);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        respondXML = __output.getOutput();

        String _session_detail = respondXML;
        cgl.fthpis.datatype.SessionDetailDocument _cDoc = null;
        try {
            _cDoc = cgl.fthpis.datatype.SessionDetailDocument.Factory.parse(
                    _session_detail);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        cgl.fthpis.datatype.SessionDetail _cdetail = _cDoc.getSessionDetail();
        _session_arr = _cdetail.getSessionEntityArray();

        for (int i = 0; i < _session_arr.length; i++) {

            cgl.fthpis.datatype.SessionEntity _session = _session_arr[i];

            System.out.println("session => session key = " +
                               _session.getSessionKey());
            System.out.println("session => name =        " + _session.getName());
            if (_session.getDescription() != null) {
                System.out.println("session => session desc = " +
                                   _session.getDescription().getValue());
            }

            cgl.fthpis.datatype.Lease lease = _session.getLease();
            if (lease != null) {
                System.out.println("context is infinite = " +
                                   lease.getIsInfinite());
            }
        }

        cgl.fthpis.datatype.DeleteSessionDocument __pDoc = cgl.fthpis.datatype.
                DeleteSessionDocument.Factory.newInstance();
        cgl.fthpis.datatype.DeleteSession dsession = __pDoc.addNewDeleteSession();

        String[] id = new String[1];
        id[0] = key;
        dsession.setSessionKeyArray(id);

        System.out.println(dsession.xmlText());

        System.out.println(__pDoc.xmlText());

        respondXML = "";

        cgl.fthpis.generic.datatype.HybridFunctionDocument deleteDoc = cgl.
                fthpis.generic.datatype.
                HybridFunctionDocument.Factory.newInstance();
        cgl.fthpis.generic.datatype.HybridFunction hybrid___Func = deleteDoc.
                addNewHybridFunction();
        hybrid___Func.setSpecName("WS-CONTEXT");
        hybrid___Func.setMethodName("delete_session");
        hybrid___Func.setRequestXML(__pDoc.copy());

        HYBRID_SERVICEStub.Input ___input = new HYBRID_SERVICEStub.Input();
        ___input.setInput(deleteDoc.xmlText());
        HYBRID_SERVICEStub.Output ___output = null;
        try {
            ___output = stub.hybrid_function(___input);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        respondXML = ___output.getOutput();

        String delete_detail = respondXML;
        cgl.fthpis.datatype.DispositionReportDocument __cDoc = null;
        try {
            __cDoc = cgl.fthpis.datatype.DispositionReportDocument.Factory.
                     parse(delete_detail);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        cgl.fthpis.datatype.DispositionReport report = __cDoc.
                getDispositionReport();

    }


    public static void main(String[] args) {

        PublishSession publish_session = new PublishSession();

    }
}
